#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
#include	"ksysprot.h"
#include	"kawkfunc.h"
/*EXTERNAL*/
/**/
char    *
formnull()          /* return the format file name */
{
    if(isnull(ffn)) print("\007<no format file>\n");
    return(ffn);
}
char    *
formfile(is)        /* set the format file name */
char    *is;
{
    if(isnull(is))  {
        listfile();
        return(NULL);
        }
    ffn = free_if(ffn);
    ffn = xpandsh(is,NULL);
    return(ffn);
}
char    *
cmdfile(argc,argv)  /* get files from command line */
int	 	argc;
char	*argv[];
{
/**/
    zerofile();
/**/
	rfn = free_if(rfn);
/**/
	rfn = cmdlist(argc,argv,ZERO,NULL);
/**/
	nfile = filecnt(rfn);
/**/
	return(rfn);
}
filecnt(is)
char	*is;
{
	if(isnull(is))	return(0);
	else			return(strcnt(strcnd(is),' ') + 1);
}
void
listfile()      /* report on the input files */
{
	if(isnull(ffn))	printf("NO FORMAT FILE\n");
	else		printf("FORMAT FILE\n");
	filespec(ffn);
	if(isnull(rfn))	printf("NO READ FILES\n");
	else		printf("READ FILES\n");
	filespec(rfn);
	return;
}
filespec(is)
char	*is;
{
	auto	char	fn[FNMSIZ];
	auto	int		fc = 0;
	auto	long	fs;
	auto	char	*fm;
	while((int) (is = xgnc(fn,fn+FNMSIZ,is,' ')))	{
		if((fs = filesize(fn)) >= 1L)	{
			fm = filemod(fn);
			}
		else	{
			fs = 0L;
			fm = "<new file>";
			}
		printf("%3d %6ld %10s %s\n",fc,fs,fm,fn);
		fc += 1;
		if(fc % 20 == 0)	{
			fflush(stdout);
			if(query(stderr) == 'q')	break;
			}
		}
	return;
}
char	*
termfile(is)        /* get files from terminal */
char    *is;
{
/**/
	if(isnull(is))	{
		listfile();
		return(NULL);
		}
/**/
    zerofile();
/**/
	rfn = free_if(rfn);
/**/
	rfn = xpandsh(is,NULL);
/**/
	nfile = filecnt(rfn);
/**/
    return(rfn);
}
char    *
getofn()
{
    return(ofn);
}
FILE    *
setofn(is,mo)
char    *is;
char    *mo;
{
	static	char	*ob = NULL;
	if(!ob)	ob = emalloc(bufsiz(),"setofn");
/*
**  open output file and return pointer to saved name
**  if no file, close and set ofp to stdout; may screw up
**  if ofp previously open as pipe
*/
	if(ofp)	fflush(ofp);	/* Sun seems to need this */
	ofp = xfclose(ofp);
	ofn = free_if(ofn);
/**/
	if(!isnull(is))	{
		ofp = tefopen(is,mo);
		}
	else	{
		is = "stdout";
    	ofp = stdout;
		}
	setbuf(ofp,ob);
	ofn = strsave(is);
#ifdef	DEBUG
	fprintf(stderr,"ofn(%s) stdout(%u) ofp(%u)\n",ofn,stdout,ofp);
#endif
    return(ofp);
}
zerofile()		/* zero the input file list */
{
	cfn = (char *) NULL;
	xfclose(cfp);
	cfp = NULL;
    return(count = cfile = 0);
}
FILE    *
getfile()       /* open and return next file pointer */
{
	static	char	*rb = NULL;
	if(!rb)	rb = emalloc(bufsiz(),"getfile");
/*
**	(a)	if there are no named input files, return stdin.
**	(b)	if there are named input files, return a pointer to
**		the first until eof occurs, then to the second, etc.
*/
	if(nfile == 0)	{
		if(cfp)		{
			if(!feof(cfp))						return(cfp);
			else								return((NULL));
			}
		if(kenv.prompt)	{
			errmsg("getfile <trying to read terminal>\n");
			}
		cfp = stdin;
		}
	else	{
		if(cfp)	{
			if(!feof(cfp))						return(cfp);
			if(cfile >= nfile)					return(NULL);
			cfp = xfclose(cfp);
			}
		if(cfile >= nfile)						return(NULL);
		cfp = tefopen(cfn = gnf(cfile++),"r");
		setbuf(cfp,rb);
		}
	return(cfp);
}
FILE	*
eofread(fp)
FILE	*fp;
{
	errmsg("eofread <attempt to read beyond end of file>\n");
	terror(FUBAR);
	return(fp);
}
xfeof(fp)
FILE	*fp;
{
	if(fp && feof(fp))	return(1);
	else				return(0);
}
char	*
gnf(nf)		/* get the n-th file */
int		nf;	/* this must be int for do loop to work */
{
	static	char	fn[FNMSIZ];
	auto	char	*os = rfn;
	fn[0] = ZERO;
	do	{
		os = xgnc(fn,fn+FNMSIZ-1,os,' ');
		}	while(--nf >= 0 && os)	;
	return(fn);
}
char    *
infile(nf)
NOSIGN	nf;
{
    if(nf >= nfile) {
		errmsg("infile <not that many files> %d >= %d\n",nf,nfile);
		terror(FUBAR);
        }
    return(gnf(nf));
}
zerocount()
{
    return(count = 0);
}
