#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
/**/
#include	"ksysprot.h"
#include	"kawkfunc.h"
/**/
#define 	TERMINAL    		"/usr/dev/tty"
/**/
/*EXTERNAL*/
extern	unsigned	long	crcsum();
extern	unsigned	long	crcinit();
extern	void				addbfcrc();
void
kcrchash(na,ap)
int		na;
DATUM	*ap;
{
	crcinit();
	addbfcrc(ap[0].v.ptr,strlen(ap[0].v.ptr));
	rdx.v.ivalu = (int) (crcsum() % (long) ap[1].v.ivalu);
	pusher = ipush;
}
kcrcsum(na,ap)
int		na;
DATUM	*ap;
{
	extern	double	dcrcsum();
	rdx.v.dvalu = 0.0;
	if(ap[0].v.ptr == NULL)		crcinit();
	else	{
		addbfcrc(ap[0].v.ptr,strlen(ap[0].v.ptr));
		rdx.v.dvalu = dcrcsum();
		}
	pusher = dpush;
}
void
khaspat(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = haspat(ap[0].v.ptr,ap[1].v.ptr);
    pusher = spush;
}
void
kstrkmp(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = (int) strkmp(ap[0].v.ptr,ap[1].v.ptr);
    pusher = ipush;
}
void
kstrnkmp(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = (int) strnkmp(ap[0].v.ptr,ap[1].v.ptr,ap[2].v.ivalu);
    pusher = ipush;
}
void
kstrkat(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = strkat(ap[0].v.ptr,ap[1].v.ptr,ap[2].v.ptr);
    pusher = spush;
}
void
kstrxty(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = strxty(ap[0].v.ptr,ap[1].v.ivalu,ap[2].v.ivalu);
    pusher = spush;
}
void
kmaximum(na,ap)
int     na;
DATUM   *ap;
{
    auto    int     tv;
    auto    int     nax;
    tv = ap[0].v.ivalu;
    for(nax = 1; nax < na; nax++)   {
        if(ap[nax].v.ivalu > tv)  tv = ap[nax].v.ivalu;
        }
    rdx.v.ivalu = tv;
	pusher = ipush;
}
void
kminimum(na,ap)
int     na;
DATUM   *ap;
{
    auto    int     tv;
    auto    int     nax;
    tv = ap[0].v.ivalu;
    for(nax = 1; nax < na; nax++)   {
        if(ap[nax].v.ivalu < tv)  tv = ap[nax].v.ivalu;
        }
    rdx.v.ivalu = tv;
	pusher = ipush;
}
#define		ALNUM	1
#define		ALPHA	2
#define		DIGIT	3
#define		LOWER	4
#define		PUNCT	5
#define		SPACE	6
#define		UPPER	7
#define		PRINT	8
#define		CNTRL	9
void
istype(na,is,ty,cx)
int		na;
char	*is;
int		ty;
int		cx;
{
/**/
/**/
	switch(ty)	{
	case	ALNUM:	rdx.v.ivalu = isalnum(cx);
	when	ALPHA:	rdx.v.ivalu = isalpha(cx);
	when	DIGIT:	rdx.v.ivalu = isdigit(cx);
	when	LOWER:	rdx.v.ivalu = islower(cx);
	when	PUNCT:	rdx.v.ivalu = ispunct(cx);
	when	SPACE:	rdx.v.ivalu = isspace(cx);
	when	UPPER:	rdx.v.ivalu = isupper(cx);
	when	PRINT:	rdx.v.ivalu = isupper(cx);
	when	CNTRL:	rdx.v.ivalu = isupper(cx);
					break;
	}
	pusher = ipush;
}
void
kiscntrl(na,ap)
int     na;
DATUM   *ap;
{
	istype(na,"isalpha",ALPHA,ap[0].v.ivalu);
}
void
kisprint(na,ap)
int     na;
DATUM   *ap;
{
	istype(na,"isalpha",ALPHA,ap[0].v.ivalu);
}
void
kisalpha(na,ap)
int     na;
DATUM   *ap;
{
	istype(na,"isalpha",ALPHA,ap[0].v.ivalu);
}
void
kisdigit(na,ap)
int     na;
DATUM   *ap;
{
	istype(na,"isdigit",DIGIT,ap[0].v.ivalu);
}
void
kisupper(na,ap)
int     na;
DATUM   *ap;
{
	istype(na,"isupper",UPPER,ap[0].v.ivalu);
}
void
kislower(na,ap)
int     na;
DATUM   *ap;
{
	istype(na,"islower",LOWER,ap[0].v.ivalu);
}
void
kispunct(na,ap)
int     na;
DATUM   *ap;
{
	istype(na,"ispunct",PUNCT,ap[0].v.ivalu);
}
void
kisalnum(na,ap)
int     na;
DATUM   *ap;
{
	istype(na,"isalnum",ALNUM,ap[0].v.ivalu);
}
void
kisspace(na,ap)
int     na;
DATUM   *ap;
{
	istype(na,"isspace",SPACE,ap[0].v.ivalu);
}
void
ksetked(na,ap)
int     na;
DATUM   *ap;
{
    auto    int bs;
    if(na == 0) bs = BLKSIZ;
    else
    if(na == 1) bs = ap[0].v.ivalu;
    kb.base = kb.bmax = kb.used = free_if(kb.base);
    kb.base = kb.used = emalloc( (unsigned) bs,"setked");
    kb.bmax = kb.base + bs - 1;
    rdx.v.ptr = kb.base;
	pusher = spush;
}
void
kmktemp(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = maketemp(ap[0].v.ptr);
    if(isnull(rdx.v.ptr))  {
/*###kafuncs3.c(196) : warning 16: `errmsg' : no function return type???*/
        errmsg("maketemp <bad format> '%s'\n",ap[0].v.ptr);
        terror(FUBAR);
        }
    pusher = spush;
}
void
knumstr(na,ap)
int     na;
DATUM   *ap;
{
	if(na == 0)	rdx.v.ivalu = numstr(NULL);
	else
	if(na == 1) rdx.v.ivalu = numstr(ap[0].v.ptr);
    pusher = ipush;
}
void
kstrnum(na,ap)
int     na;
DATUM   *ap;
{
	rdx.v.ptr = strnum(ap[0].v.ivalu);
    pusher = spush;
}
void
kstrhow(na,ap)
int     na;
DATUM   *ap;
{
	rdx.v.ivalu = strhow();
    pusher = ipush;
}
void
esprt(na,ap)
int		na;
DATUM	*ap;
{
	rdx.v.ivalu = fprintf(stderr,"es %u esx %u esu %u\n",es,esx,esu);
	pusher = ipush;
	return;
}
