#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
/**/
#define		MASK	'\040'
#define		BACK	'\b'
#define		THYP	1		/* tentative */
#define		PHYP	2		/* prefix */
#define		SHYP	4		/* suffix */
#define		EHYP	8		/* embedded */
#define		mask(x)((x | MASK))	
/**/
/*EXTERNAL*/
extern	char	*blkrd();
/*STATIC*/
int	hypbug;
int	hypmod = DA | DB | DC | DD;
static	char	tblcall;		/* has tblset been called? */
static  char    **pre;          /* prefix array */
static  char    **suf;          /* suffix array */
static  char    **xcl;          /* exclusion list */
static  int     npre;			/* number of prefixes */
static  int     nsuf;			/* number of suffixes */
static  int     nxcl;			/* number of exclusions */
/*
*/
xhy(nv,is)              /* set hyphenation */
char    *is;
{
	x[nv].hy = setvar(nv,is,ABSO,x[nv].hy,8);
	return(x[nv].hy);
}
tblset()				/* set pre, suf, exl tables */
{
	static	char	*lsuf[] = { "pre", "suf", "xcl", NULL };
	auto	char	**sfx = lsuf;
	auto	char	**bsx;
	auto	char	*osx = NULL;
	auto	char	ws[FNMSIZ];
	auto	char	*pub = getenv("PUBKIN");
	auto	int		cnt = 0;
	auto	int		siz = 0;
/**/
	if(!pub)	{
		errmsg("tblset <PUBKIN undefined>\n");
		terror(FUBAR);
		}
/**/
	while(*sfx != ZERO)	{
/**/
	sprintf(ws,"%s/kroff.%s",pub,*sfx);
/**/
	osx = blkrd(ws);
/**/
	cnt = strcnt(osx,'\n') + 1;
/**/
	bsx = (char **) emalloc( cnt * sizeof(char **) ,"tblset:tar");
/**/
	siz = splitc(bsx,cnt,osx,'\n');
/**/
	if(strcmp(*sfx,"pre") == 0)		{
		pre = bsx;
		npre = siz;
		}
	else
	if(strcmp(*sfx,"suf") == 0)		{
		suf = bsx;
		nsuf = siz;
		}
	else
	if(strcmp(*sfx,"xcl") == 0)		{
		xcl = bsx;
		nxcl = siz;
		}
	else	{
		errmsg("tblset <bad sfx>\n");
		terror(FUBAR);
		}
	sfx += 1;
	}
	return(ZERO);
}
char    *
hyphen(os,us,is,ne,hy)      /* perform hyphenation */
char	*os;
char	*us;
char	*is;
int	ne;
int	hy;
{
	REG		unsigned	char	*isx = is;
	REG		unsigned	char	*osx = os + 2;
	auto				int		lc;				/* last character */
	auto				int		ty;				/* type of hyphenation */
	auto				int		rt;				/* return in pre-suf array */
	auto				int		tw;				/* total width */
	auto				int		ww;				/* word width */
	auto	unsigned	char	*ep = NULL;		/* end for prefix */
	os[WOFF] = os[WLEN] = ty = tw = ww = ZERO;
/*
**  left part of word is in os following "wordcopy"
**  conventions.
**  return is next position in is or NULL if no
**  hyphenation done
*/
	if(!tblcall)	{
		tblset();
		tblcall = YES;
		}
/*	skip initial blanks */
	while(*isx != ZERO && isspace(*isx))	++isx;
/*	reset "is" to beginning of "word" */
	is = isx;
/*	skip initial punctuation */
	while(*isx != ZERO)	{
		if(isalnum(*isx))	break;
		if(*isx == THP)		return(NULL);
		tw += pwc(*isx);
		isx += 1;
		}
/*	adjust need based on intial punctuation */
	ne -= tw;
	if(ne < 3)				return(NULL);
/*	check for a prefix */
	rt = findpre(pre,npre,isx,ne);
	if(rt >= ZERO)	{
		auto	int	lpre = strlen(pre[rt]);
		if( (tw + lpre) >= ne )		ep = NULL;
		else						ep = isx + lpre;
		if(ep && (rt = findsuf(suf,nsuf,ep)) >= 0)	{
			ty = PHYP;
			}
		else	{
			ep = NULL;
			}
		}
/*	scan for suffixes, included and designated hyphens */
	lc = ZERO;
	while(*isx != ZERO && !isspace(*isx) && tw < ne)	{
		tw += pwc(*isx);
		ww += pwc(*isx);
		if(ty != THYP && *isx == '-' && isalnum(lc))	{
			ty = EHYP;
			ep = isx + 1;
			}
		else
		if(*isx == THP)	{
			ty = THYP;
			ep = isx + 1;
			}
		else
		if(ty != THYP && ww > 3 && (rt = findsuf(suf,nsuf,isx)) >= 0)	{
			if((tw+1) >= ne)	break;
			ty = SHYP;
			ep = isx;
			}
		lc = *isx++;
		}
/*	if hyphen point found, copy up to it */
	if(ep == NULL)	return(NULL);
	isx = is;
	while(isx < ep)	{
		os[WLEN] += pwc(*isx);
		os[WOFF] += 1;
		*osx++ = *isx++;
		}
	if(ty == PHYP || ty == SHYP || ty == THYP)	{
		os[WLEN] += pwc('-');
		os[WOFF] += 1;
		*osx++ = '-';
		}
	*osx++ = STOP;
	*osx = ZERO;
	os[WOFF] += 2;
	return(ep);
}
tail(is)        /* return the length of word tail */
char    *is;
{
/*
**  should be called with os + 2 to avoid false
**  counts when a ^H results from the fragment
**  size
*/
	REG     unsigned	char    *isx = is;
	REG     			int     pw = 0;
	while(*isx != ZERO && !isspace(*isx))   {
		pw += pwc(*isx);
		isx += 1;
		}
	return(pw);
}
findpre(bs,nbs,is,ne)
char	**bs;
int	nbs;
char	*is;
int	ne;
{
	auto	int	hold;
	auto	int	retr;
	hold = is[ne];
	is[ne] = ZERO;
	retr = findsuf(bs,nbs,is,ne);
	is[ne] = hold;
	return(retr);
}
findsuf(os,nos,is)   /* find is in os (size nos) */
char	*os[];
char	*is;
int 	nos;
{
/*  these must be integer for this to work */
	REG     int low;
	REG     int mid;
	REG     int high;
	REG     int cond;
	if(isnull(is))      return(-1);
	low = 0;
	high = nos -1;
	while(low <= high)
	{
	mid = (low + high) / 2;
	cond = mask(*is) - mask(*os[mid]);
	if(cond < 0)        high = mid -1;
	else if(cond > 0)   low = mid + 1;
	else                break;
	}
	if(low > high)      return(-1);
	while(low <= high)
	{
		mid = (low + high) / 2;
		cond = substr(is,os[mid]);
		if(cond < 0)        high = mid -1;
		else if(cond > 0)   low = mid + 1;
		else    
			{
			return(mid);
			}
		}
	return(-1);
}
substr(os,is)       /* is a substring of os ? */
char	*os;
char	*is;
{
	REG     char    *osx = os;
	REG     char    *isx = is;
	for( ; *isx && *osx && mask(*osx) == mask(*isx); osx++,isx++) ;
	return((*isx ? (mask(*osx) - mask(*isx)) : 0));
}
