/*
	(c) 1989 by Earl H. Kinmonth
*/
/*
	this is an implementation of the memory allocator given in
	Kernighan and Ritchie, THE C PROGRAMMING LANGUAGE (1978),
	pp. 173-178.
*/
/*
|	far_realloc() has NOT been tested
*/
/*UNXLIB*/
#ifdef		M_XENIX
#include	<stdio.h>
#include	<sys/brk.h>
#include	"faralloc.h"
/**/
static	long	mask;
static	HEADER	huge	*base;
static	HEADER	huge	*allocp;
/**/
/*EXTERN*/
char	far	*
far_realloc(os,nbytes)
char	far		*os;
SIZE_M			nbytes;
{
	auto	HEADER	huge	*osx;
	auto	char	far		*rs;
	auto	SIZE_M			ix;
	if(os == FAR_NULL)	abort();
	far_free( os );
	rs = far_malloc( nbytes );
	if(rs == FAR_NULL)	return( FAR_NULL );
	if(rs == os)		return( rs );
	osx = (HEADER huge *) (os - 1);
	for(ix = 0; ix < osx->s.size; ix++) rs[ix] = os[ix];
	return( rs );
}
char	far	*
far_malloc(nbytes)
SIZE_M	nbytes;
{
	register		HEADER	huge		*p;
	register		HEADER	huge		*q;
	register		SIZE_M	nunits;
/**/
	nunits = 1 + (nbytes + sizeof(HEADER) - 1) / sizeof(HEADER);
/**/
	if((q = allocp) == FAR_NULL)	{
		base = (HEADER huge *) brkctl(BR_NEWSEG,(SIZE_M) sizeof(HEADER),FAR_NULL);
		base->s.ptr = allocp = q = base;
		base->s.size = 0;
		}
/**/
	for( p = q->s.ptr; ; q = p, p = p->s.ptr)	{
		if(p->s.size >= nunits)		{
			if(p->s.size == nunits)	{
				q->s.ptr = p->s.ptr;
				}
			else	{
				p->s.size -= nunits;
				p += p->s.size;
				p->s.size = nunits;
				}
			allocp = q;
			return( (char far	*) (p + 1) );
			}
/**/
		if(p == allocp)	{
			p = (HEADER huge *) far_morecore(nunits);
			if((char far *) p == FAR_NULL)	return(FAR_NULL);
			}
		}
}
static	HEADER	far	*
far_morecore(nunits)
SIZE_M	nunits;
{
	auto		char	far		*cp;
	auto		HEADER	far		*up;
	auto		SIZE_M	rnu;
	auto		SIZE_M	lsize;
/**/
	rnu = NALLOC * ((nunits+NALLOC-1) / NALLOC);
	lsize = rnu * sizeof(HEADER);
	cp = brkctl(BR_IMPSEG,lsize,FAR_NULL);
	if(cp == (char far	 *) -1)	return(FAR_NULL);
	up = (HEADER far	 *) cp;
	up->s.size = rnu;
	far_free( (char far	 *) (up + 1));
	return( (HEADER far *) allocp );
}
char	far	*
far_free(ap)
char	far		*ap;
{
	register	HEADER	huge		*p;
	register	HEADER	huge		*q;
	p = (HEADER huge		*) ap - 1;
/**/
	for(q = allocp; !(p > q && p < q->s.ptr); q = q->s.ptr)	{
		if(q >= q->s.ptr && (p > q || p < q->s.ptr))
			break;
		}
/**/
	if(p + p->s.size == q->s.ptr)	{
		p->s.size += q->s.ptr->s.size;
		p->s.ptr = q->s.ptr->s.ptr;
		}
	else	p->s.ptr = q->s.ptr;
/**/
	if(q + q->s.size == p)	{
		q->s.size += p->s.size;
		q->s.ptr = p->s.ptr;
		}
	else	q->s.ptr = p;
/**/
	allocp = q;
/**/
	return( NULL );
}
#ifdef	TEST
char	far	*
far_strsave(is)
char	*is;
{
	auto		int			ls = strlen(is) + 1;
	auto		char	far	*rs = far_malloc( (SIZE_M) ls );
	register	char	far	*rsx = rs;
	if(rs == NULL)	return( NULL );
	while(*is != 0)	*rsx++ = *is++;
	*rsx = 0;
	return( rs );
}
far_puts(os)
char	far	*os;
{
	while(*os != 0)	putchar(*os++);
	putchar('\n');
}
main()
{
	auto	char	ls[BUFSIZ];
	auto	char	far	*rx;
	extern	long	atol();
	while(1)	{
		putchar('?');
		if(!gets(ls))	break;
		switch(ls[0])	{
			case	'!':	system(ls+1);break;
			case	'#':	far_free(rx);break;
			case	'@':	rx = far_malloc(atol(ls+1));
							fprintf(stderr,"rx(%lu)\n",rx);
							break;
			case	'q':	exit(0);
			}
		}
}
#endif
#ifdef	DEBUG
#include	<sys/types.h>
#include	<sys/sysmacros.h>
far_prt(name,is)
char			*name;
char	far		*is;
{
/*
	seg * 16 + off = physical address
*/
	auto	long		offset = ftooff(is);
	auto	long		segmnt = ftoseg(is);
	auto	long		phyadr = ftop(is);
	fprintf(stderr,"name( %s ) ",name);
	fprintf(stderr,"offset(%lu) segmnt(%lu) phyadr(%lu) ",
		offset,segmnt,phyadr);
	fprintf(stderr,"\n");
}
#endif	/*DEBUG*/
#else	/*M_XENIX*/
typedef	unsigned	long	SIZE_M;
extern	char	*malloc();
extern	char	*realloc();
extern 	void	free();
void
far_free(os)
char	*os;
{
	free(os);
	return;
}
char	*
far_malloc(size)
SIZE_M	size;
{
	return(malloc((unsigned)size));
}
char	*
far_realloc(os,size)
char	*os;
SIZE_M	size;
{
	return(realloc(os,(unsigned)size));
}
#endif	/*M_XENIX*/
