/*
**      WARNING:
**      various versions of the toupper/tolower macros causes
**      problems.
**      some versions (the X86 for example) mess up *is++
**      constructs.
**      some versions may mess up numbers and punctuation by
**      not checking whether the parameter is in range or not
**
**      ksysconv.h contains two arrays that are used to
**      produce safe conversions
*/
/*
	10,09,85:   added \u\U \l\L \e\E following ex
	89:02:10:	added function prototypes, corrected call to
				strnkat
*/
/**/
#include    	"ksysdefs.h"
#include    	"ksysvtyp.h"
/**/
#include        "ksysconv.h"
/**/
#ifndef		HUGE
#define		HUGE	9999
#endif
#define         CHARMASK        '\177'          /* force ascii character */
#ifdef          toupper
#undef          toupper
#undef          tolower
#endif
#define         toupper(x)(_toup[x&CHARMASK])
#define         tolower(x)(_tolo[x&CHARMASK])
/**/
#define     CBRA        1
#define     LIT         2
#define     ANY         4
#define     CCL         6
#define     NCCL        8
#define     BOL         9   /* ehk */
#define		CBOL		'^'
#define     EOL         10
#define     CEOF        11
#define     CKET        12
#define     SWITCH      13  /* ehk */
#define     WORD_LEFT   14  /* ehk: word matching */
#define     WORD_RIGHT  15
#define     CBACK       18
#define     CLOSURE     01
#define     ESIZE       512
#define     NBRA        9
/**/
static  char    expbuf[ESIZE];	/* the compiled pattern */
static  char    *bes[NBRA];
static  char    *bel[NBRA];
static  struct  PATLOC  {
	char    *beg;
	char    *end;
}   ptl;
struct  PATLOC  *pdq;
static  int     cerrnum =   0;
static  int     nocase  =   NO;
static  int     onwords =   NO;
/*
*/
static  char *cerrs[]={
	"okay",
	"regular expression too long",
	"no previous regular expression",
	"unmatched \\(",
	"missing ]",
	"too many \\(\\) pairs",
	"faulty escape"
	};
/**/
/*EXTERN*/
#ifdef	CAN_PROTO
extern char *strnkat(char *,char *, char *,unsigned int);
extern char *dsub2(char *);
extern char *dsub1(char *,char *,char *);
extern int dsub(char *,char *,char *,char *,int,int);
extern int cclass(char *,char,int);
extern int backref(int,char *);
extern int isword(char);
extern int advance(char *,char *);
extern struct PATLOC *re_sexec(char *,char *);
extern struct PATLOC *re_exec(char *);
extern struct PATLOC *re_ploc(char *);
extern char *re_comp(char *);
extern char *re_cpat(char *,int);
extern char *rex_errs(int);
#else	/*CAN_PROTO*/
extern char *strnkat();
extern char *dsub2();
extern char *dsub1();
extern int dsub();
extern int cclass();
extern int backref();
extern int isword();
extern int advance();
extern struct PATLOC *re_sexec();
extern struct PATLOC *re_exec();
extern struct PATLOC *re_ploc();
extern char *re_comp();
extern char *re_cpat();
extern char *rex_errs();
#endif	/*CAN_PROTO*/
/**/
char    *
rex_errs(n)
int n;
{
	if(n < sizeof(cerrs)/sizeof(char *) )   return(cerrs[n]);
	else                                    return("?????");
}
/* ------------------------------------------------------------ */
/*
	return the compiled pattern (ehk)
*/
char    *
re_cpat(s,ms)
char *s;
int ms;
{
	char *so,*cpx;
	so = s;
	cpx=expbuf;
	while(*cpx != ZERO && cpx < &so[ms] ) *s++ = *cpx++;
	*s++ = CEOF;
	*s++ = ZERO;
	return(s);
}
/* ------------------------------------------------------------ */
#ifdef	DEBUG
static	long	checksum = 0L;
long
setsum(is)
char	*is;
{
	auto	long	sum = 0L;
	/* funxesc(is,stderr); */
	while(*is)	sum += *is++;
	/* fprintf(stderr,"sum(%ld)\n",sum); */
	return(sum);
}
#endif
char *
re_comp(sp)
register char    *sp;
{
	register int    c;
	register char    *ep = expbuf;
	int    cclcnt, numbra = 0;
	auto    char    *lastep = 0;
	auto    char    bracket[NBRA];
	auto    char    *bracketp = &bracket[0];
	auto    char    *exx;
	extern  char    *strchr();
	if(strncmp(sp,"<>",2) == 0) print("re_comp: [%s]\n",sp = sp+2);
	cerrnum=0;
	if (sp == 0 || *sp == ZERO) {
		if (*ep == 0) return((char *) (cerrnum=1));
		return(0);}
	if(*sp == CBOL)	*ep++ = *sp++;
	else			*ep++ = ' ';
	if((int) (exx = strchr(sp,'\\')))    {
		if(exx[1] == ZERO)  {
			return( (char *) 6);
			}
		}
	for( ; ; )  {
		if (ep >= &expbuf[ESIZE])
			return((char *) (cerrnum=1));
		if ((c = *sp++) == '\0') {
			if (bracketp != bracket)
				return((char *) (cerrnum=3));
			*ep++ = CEOF;
			*ep++ = 0;
#ifdef	DEBUG
	checksum = setsum(expbuf);
#endif
			return(0);
		}
		if (c != '*')
			lastep = ep;
		switch (c) {
		case '.':
			*ep++ = ANY;
			continue;
		case '*':
			if (lastep == 0 || *lastep == CBRA || *lastep == CKET)
				goto defchar;
			*lastep |= CLOSURE;
			continue;
		case '$':
			if (*sp != '\0')
				goto defchar;
			*ep++ = EOL;
			continue;
		case '[':
			*ep++ = CCL;
			*ep++ = 0;
			cclcnt = 1;
			if ((c = *sp++) == CBOL) {
				c = *sp++;
				ep[-2] = NCCL;
			}
			do {
				if (c == '\0')
					return((char *) (cerrnum=4));
				if (c == '-' && ep [-1] != 0) {
					if ((c = *sp++) == ']') {
						*ep++ = '-';
						cclcnt++;
						break;
					}
					while (ep[-1] < c) {
						*ep = ep[-1] + 1;
						ep++;
						cclcnt++;
						if (ep >= &expbuf[ESIZE])
							return((char *) (cerrnum=1));
					}
				}
				*ep++ = c;
				cclcnt++;
				if (ep >= &expbuf[ESIZE])
					return((char *) (cerrnum=1));
			} while ((c = *sp++) != ']');
			lastep[1] = cclcnt;
			continue;
		case '\\':
			if ((c = *sp++) == '(') {
				if (numbra >= NBRA)
					return((char *) (cerrnum=5));
				*bracketp++ = numbra;
				*ep++ = CBRA;
				*ep++ = numbra++;
				continue;
			}
			if (c == ')') {
				if (bracketp <= bracket)
					return((char *) (cerrnum=3));
				*ep++ = CKET;
				*ep++ = *--bracketp;
				continue;
			}
			if (c >= '1' && c < ('1' + NBRA)) {
				*ep++ = CBACK;
				*ep++ = c - '1';
				continue;
			}
	/* ------------------------------ */
	if(c == '<') {*ep++ = WORD_LEFT;continue;}
	if(c == '>') {*ep++ = WORD_RIGHT;continue;}
	if(c == 'i') {*ep++ = SWITCH;*ep++ = c;continue;}
	if(c == 'I') {*ep++ = SWITCH;*ep++ = c;continue;}
	/* ------------------------------ */
			*ep++ = LIT;
			*ep++ = c;
			if(*sp == ZERO) {
				*ep++ = CEOF;
#ifdef	DEBUG
				checksum = setsum(expbuf);
#endif
				return(NULL);
				}
			continue;
		defchar:
		default:
			*ep++ = LIT;
			*ep++ = c;
		}
	}
}
/* 
 * match the argument string against the compiled re
 */
struct  PATLOC  *
re_ploc(s)
char *s;
{
	re_exec(s);
	if(ptl.beg==NULL) return(NULL);
	if(ptl.end==NULL) ptl.end = ptl.beg;
	return(&ptl);
}
struct  PATLOC  *
re_exec(p1)
char *p1;
{
#ifdef	DEBUG
	if(setsum(expbuf) != checksum)	{
		errmsg("<queer pattern> ");
		funxesc(expbuf,stderr);
		}
#endif
	return(re_sexec(p1,expbuf));
}
struct  PATLOC  *
re_sexec(p1,pscode)
char *pscode;
register char    *p1;
{
	register char    *p2 = pscode;
	register int    c;
	int    rv;
	for (c = 0; c < NBRA; c++) {
		bes[c] = 0;
		bel[c] = 0;}
	/* ------------------------------ */
	nocase = onwords = NO;
	ptl.beg = ptl.end = NULL;
	/* ------------------------------ */
	if(*p2++ == CBOL)	{
		rv = advance(p1, p2);
		if(rv) {
			ptl.beg = p1;
			return(&ptl);
			}
		else 	return(NULL);
		}
	/*
	 * fast check for first character
	 */
	if (*p2 == LIT) {
		c = p2[1];
		do {
			if (*p1 != c)
				continue;
			if ((int)(rv = advance(p1, p2)))
				{ptl.beg=p1;return(&ptl);}
		} while (*p1++);
		return(0);
	}
	/*
	 * regular algorithm
	 */
	do
		if ((int)(rv = advance(p1, p2)))
			{ptl.beg=p1;return(&ptl);}
	while (*p1++);
	return(0);
}
/* 
 * try to match the next thing in the dfa
 */
advance(lp, ep)
	register char    *lp, *ep;
{
	register char    *curlp;
	int    c,ct, i;
	int    rv;
	/*  print("lp = [%s]\n",lp);    */
	for (;;)
		switch (*ep++) {
	/* ------------------------------ */
	case SWITCH:
		c = *ep++;
		if(c == 'i') {nocase=YES;continue;}
		if(c == 'I') {nocase=NO;continue;}
		errmsg("switching error\n");
		return(NO);
	/* ------------------------------ */
		case LIT:
	/* ------------------------------ */
	if(*lp == *ep)
		{ ep++; lp++; continue; }
	else    return(NO);
	/* ------------------------------ */
		case ANY:
			if (*lp++)
				continue;
			return(0);
		case EOL:
			if (*lp == '\0')
				continue;
			return(0);
		case CEOF:
			if(lp > ptl.end) ptl.end = lp;
			return(1);
		case CCL:
			if (cclass(ep, *lp++, 1)) {
				ep += *ep;
				continue;
			}
			return(0);
		case NCCL:
			if (cclass(ep, *lp++, 0)) {
				ep += *ep;
				continue;
			}
			return(0);
		case CBRA:
			bes[*ep++] = lp;
			continue;
		case CKET:
			bel[*ep++] = lp;
			continue;
		case CBACK:
			if (bel[i = *ep++] == 0)
				return(-1);
			if (backref(i, lp)) {
				lp += bel[i] - bes[i];
				continue;
			}
			return(0);
		case CBACK|CLOSURE:
			if (bel[i = *ep++] == 0)
				return(-1);
			curlp = lp;
			ct = bel[i] - bes[i];
			while (backref(i, lp))
				lp += ct;
			while (lp >= curlp) {
				if ((int)(rv = advance(lp, ep)))
					return(rv);
				lp -= ct;
			}
			continue;
		case ANY|CLOSURE:
			curlp = lp;
			while (*lp++)
				;
			goto star;
		case LIT|CLOSURE:
			curlp = lp;
		/* ------------------------------ */
		while(*lp == *ep) lp++;
		lp++;
		/* ------------------------------ */
			ep++;
			goto star;
		case CCL|CLOSURE:
		case NCCL|CLOSURE:
			curlp = lp;
			while (cclass(ep, *lp++, ep[-1] == (CCL|CLOSURE)))
				;
			ep += *ep;
			goto star;
		star:
			do {
				lp--;
				if ((int)(rv = advance(lp, ep)))
					return(rv);
			} while (lp > curlp);
			return(0);
	/* ------------------------------ */
	case    WORD_LEFT:
	if(lp == expbuf) continue;
	if(isword(*(lp-1))) {continue;}
	return(NO);
	case    WORD_RIGHT:
	if(isword(*(lp))) {continue;}
	return(NO);
	/* ------------------------------ */
		default:
		errmsg("FUBAR\n");
			return(-1);
		}
}
/* ---------------------------------------------------------------------- */
isword(c)
char c;
{
	if(c == ZERO) return(YES);
	if(isspace(c) || ispunct(c) || iscntrl(c)) return(YES);
	else return(NO);
}
/* ---------------------------------------------------------------------- */
backref(i, lp)
register int    i;
register char    *lp;
{
	register char    *bp;
	bp = bes[i];
	while (*bp++ == *lp++)
		if (bp >= bel[i])
			return(1);
	return(0);
}
int
cclass(set, c, af)
register char    *set, c;
int    af;
{
	register int    n;
	if (c == 0)
		return(0);
	n = *set++;
	while (--n)
	if(*set++ == c) return(af);
	return(! af);
}
/*
*/
/*
*/
dsub(os,us,is,rs,gl,bl)     /* perform substitution */
char    *os;    /*  output string */
char    *us;    /*  upper limit to os */
char    *is;    /*  input string */
char    *rs;    /*  replacement string */
int     gl;     /*  number of replacements to be made */
int     bl;
{
	auto        int     ns = 0;
	register    char    *isx = is;
	register    char    *osx = os;
	register    char    *usx = us - 1;
	do  {
	    if((int)(pdq = re_ploc(isx)))  {
		if(bl >= YES && pdq->beg > is)      break;
		++ns;
		--gl;
		while(osx < usx && isx < pdq->beg)  *osx++ = *isx++;
		osx = dsub1(osx,usx,rs);
		isx = pdq->end;
		if(bl >= YES || gl <= 0)            break;
		}
	}   while(osx < usx && pdq && *isx != ZERO) ;
/**/
	while(osx < usx && *isx != ZERO)            *osx++ = *isx++;
/**/
	*osx = ZERO;
/**/
	if(osx >= usx)  {
		errmsg("<dsub: overflow>\n");
		return(-1);
		}
	else    return(ns);
}
char    *
dsub1(os,us,rs)
char	*os;	/* output */
char	*us;	/* _os upper limit */
char	*rs;	/* replacement */
{
	REG	        char    *osx = os;
	REG	        char    *rsx = rs;
	REG	        char    *usx = us;
	auto		char	*beg;
	auto		char	*end;
	auto		int	ncx;
/**/
	while(osx < usx && *rsx != ZERO)	{
	if(*rsx == ESC)	{
			if(isdigit(rsx[1]))	{
				beg = bes[rsx[1] - '0' - 1];
				end = bel[rsx[1] - '0' - 1];
				ncx = end - beg;
				if(ncx)
					osx = strnkat(osx,usx,beg,ncx);
				rsx += 2;
				continue;
				}
			else
			if(rsx[1] == '&')	{
				*osx++ = rsx[1];
				rsx += 2;
				continue;
				}
			else				{
				*osx++ = *rsx++;
				*osx++ = *rsx++;
				}
			}
	else
	if(*rsx == '&')	{
		beg = pdq->beg;
		end = pdq->end;
		ncx = end - beg;
		if(ncx)
			osx = strnkat(osx,usx,beg,ncx);
		rsx += 1;
		}
	else	{
		*osx++ = *rsx++;
		}
	}
/**/
	*osx = ZERO;
/**/
	return(dsub2(os));
/**/
}
char	*
dsub2(is)	/* process case change functions */
char	*is;
{
	REG		char	*isx = is;
	REG		char	*osx = is;
	REG		int		cc = ZERO;	/* change number */
	REG		int		mx = ZERO;	/* change mask */
#define		CMASK	'\040'
	while(*isx != ZERO)	{
	if(*isx == ESC)	{
		switch(*++isx)	{
			case	'E':
			case	'e':	cc = ZERO;	break;
			case	'U':	cc = HUGE;	mx = ZERO;  break;
			case	'u':	cc = 1; 	mx = ZERO;  break;
			case	'L':	cc = HUGE; 	mx = CMASK; break;
			case	'l':	cc = 1; 	mx = CMASK; break;
			default:		*osx++ = *isx;
							break;
			}
		isx += 1;
		}
	else
	if(cc-- >= 1)		{
		if(isalpha(*isx))	{
#ifdef	DEBUG
printff("*isx = %c ",*isx);
#endif	DEBUG
			*isx &= ~CMASK;
#ifdef	DEBUG
printff("*isx = %c ",*isx);
#endif	DEBUG
			*isx = mx ? (*isx | CMASK) : *isx;
#ifdef	DEBUG
printff("*isx = %c ",*isx);
printff("\n");
#endif	DEBUG
			}
		*osx++ = *isx++;
		}
	else	{
		*osx++ = *isx++;
		}
	}
/**/
	*osx = ZERO;
/**/
#ifdef	DEBUGR
printff("dsub2: return(%s)\n",is);
#endif
	return(osx);
}
